## net.i2p.data
Class Payload

    java.lang.Object
      net.i2p.data.DataStructureImpl
          net.i2p.data.Payload

All Implemented Interfaces:
  DataStructure

public class Payload
extends DataStructureImpl

Defines the actual payload of a message being delivered, including the standard encryption wrapping, as defined by the I2P data structure spec.

Author:
  jrandom

Constructor Summary
`Payload()`

Method Summary
`boolean` `equals(java.lang.Object object)`
`byte[]` `getEncryptedData()`
`int` `getSize()`
`byte[]` `getUnencryptedData()` Retrieve the unencrypted body of the message.
`int` `hashCode()`
`void` `readBytes(java.io.InputStream in)` Load up the current object with data from the given stream.
`void` `setEncryptedData(byte[] data)`
`void` `setUnencryptedData(byte[] data)` Populate the message body with data.
`java.lang.String` `toString()`
`int` `writeBytes(byte[] target, int offset)`
`void` `writeBytes(java.io.OutputStream out)` Write out the data structure to the stream, using the format defined in the I2P data structure specification.

Methods inherited from class net.i2p.data.DataStructureImpl
`calculateHash, fromBase64, fromByteArray, read, toBase64, toByteArray`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Payload

    public Payload()

Method Detail

### getUnencryptedData

    public byte[] getUnencryptedData()

  Retrieve the unencrypted body of the message.

  Returns:
    body of the message, or null if the message has either not been decrypted yet or if the hash is not correct

### setUnencryptedData

    public void setUnencryptedData(byte[] data)

  Populate the message body with data. This does not automatically encrypt yet.

### getEncryptedData

    public byte[] getEncryptedData()

### setEncryptedData

    public void setEncryptedData(byte[] data)

### getSize

    public int getSize()

### readBytes

    public void readBytes(java.io.InputStream in)
                   throws DataFormatException,
                          java.io.IOException

  Description copied from interface: `DataStructure`
  Load up the current object with data from the given stream. Data loaded this way must match the I2P data structure specification.

  Parameters:
    `in` - stream to read from
  Throws:
    `DataFormatException` - if the data is improperly formatted
    `java.io.IOException` - if there was a problem reading the stream

### writeBytes

    public void writeBytes(java.io.OutputStream out)
                    throws DataFormatException,
                           java.io.IOException

  Description copied from interface: `DataStructure`
  Write out the data structure to the stream, using the format defined in the I2P data structure specification.

  Parameters:
    `out` - stream to write to
  Throws:
    `DataFormatException` - if the data was incomplete or not yet ready to be written
    `java.io.IOException` - if there was a problem writing to the stream

### writeBytes

    public int writeBytes(byte[] target,
                          int offset)

### equals

    public boolean equals(java.lang.Object object)

### hashCode

    public int hashCode()

### toString

    public java.lang.String toString()